Package org.optaplanner.core.impl.score.stream.drools.common.nodes

## Class AbstractConstraintModelNode

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.drools.common.nodes.AbstractConstraintModelNode

- All Implemented Interfaces:
    `ConstraintGraphNode`
  Direct Known Subclasses:
    `AbstractConstraintModelChildNode`, `FromNode`

      public abstract class AbstractConstraintModelNode
      extends Object
      implements ConstraintGraphNode

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addChildNode​(ConstraintGraphNode node)` |
    `void` | `addConsequence​(ConstraintConsequence consequence)` |
    `List<ConstraintGraphNode>` | `getChildNodes()` | Retrieves an unmodifiable collection of unique nodes which follow this one.
    `List<ConstraintConsequence>` | `getConsequences()` | Retrieves an unmodifiable collection of unique consequences having this node as a terminal node.
    `ConstraintGraphNodeType` | `getType()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.drools.common.nodes.ConstraintGraphNode

      `getCardinality, getFactType`

- - ### Method Detail

    - #### addChildNode

          public final void addChildNode​(ConstraintGraphNode node)

    - #### addConsequence

          public final void addConsequence​(ConstraintConsequence consequence)

    - #### getChildNodes

          public final List<ConstraintGraphNode> getChildNodes()

      Description copied from interface: `ConstraintGraphNode`
      Retrieves an unmodifiable collection of unique nodes which follow this one.
      Specified by:
        `getChildNodes` in interface `ConstraintGraphNode`
      Returns:
        never null, may be empty when `ConstraintGraphNode.getConsequences()` is not or when the model is not yet fully built.

    - #### getConsequences

          public final List<ConstraintConsequence> getConsequences()

      Description copied from interface: `ConstraintGraphNode`
      Retrieves an unmodifiable collection of unique consequences having this node as a terminal node.
      Specified by:
        `getConsequences` in interface `ConstraintGraphNode`
      Returns:
        never null, may be empty when `ConstraintGraphNode.getChildNodes()` is not or when the model is not yet fully built.

    - #### getType

          public final ConstraintGraphNodeType getType()

      Specified by:
        `getType` in interface `ConstraintGraphNode`